# Check for native compiler support
%global opt       %(test -x %{_bindir}/ocamlopt && echo 1 || echo 0)

# Use external dependency generator
%define _use_internal_dependency_generator 0
%define __find_provides %{_prefix}/lib/rpm/ocaml-find-provides.sh
%define __find_requires %{_prefix}/lib/rpm/ocaml-find-requires.sh

# Don't strip binaries (contains -custom builds)
%define debug_package %{nil}
%define __strip   /bin/true

%define sel_modn  selinux-policy-addon
%define sel_modv  0.2.0


Summary:          The Synchronizing Key Server
Name:             sks
Version:          1.1.0
Release:          3%{?dist}%{?pext}
License:          GPL
Group:            System Environment/Daemons
Source0:          http://minskyprimus.net/%{name}/releases/%{name}-%{version}.tgz
Source1:          %{name}-db.init
Source2:          %{name}-recon.init
Source3:          %{name}.sysconfig
Source4:          %{name}.logrotate
Patch0:           %{name}-1.1.0-paths.patch
Patch1:           %{name}-1.1.0-config.patch
Patch2:           %{name}-1.1.0-build.patch
Patch10:          %{name}-1.1.0-dbsync_on_ext_signal.patch
Patch11:          %{name}-1.1.0-ignore_sigusr2.patch
Patch12:          %{name}-1.1.0-increase_wserver_tmout.patch
Patch13:          %{name}-1.1.0-spider_add_buildtarget.patch
Patch14:          %{name}-1.1.0-spider_set_starthost.patch
Patch15:          %{name}-1.1.0-statscalc_on_ext_signal.patch
Patch16:          %{name}-1.1.0-cursor_leak_fix.patch
Patch17:          %{name}-1.1.0-userid_case_fix.patch
URL:              http://%{name}.sourceforge.net/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Yaron M. Minsky <yminsky@cs.cornell.edu>
Requires:         curl procmail
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service
BuildRequires:    ocaml >= 3.10.2 ocaml-camlp4-devel
BuildRequires:    db4-devel zlib-devel

%description
SKS (Synchronizing Key Server) is a full-featured replacement for the standard
PKS OpenPGP Key Server. It matches all of PKS features and interfaces, and at
the same time provides a highly efficient, gossip-based replication algorithm
that ensures that the replication is complete.


%package          selinux
Summary:          SELinux support for %{name}
Group:            System Environment/Base
Requires:         %{name} = %{version}-%{release}
Requires:         %{sel_modn} >= %{sel_modv}
Requires(post):   /sbin/restorecon %{_sbindir}/selinuxenabled /sbin/fixfiles

%description      selinux
This package enables %{name} to work with SELinux.


%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1

# Prepare build config
%{__cat} << \_EOF_ >Makefile.local
PREFIX=%{_prefix}
MANDIR=%{_mandir}
CONFDIR=%{_sysconfdir}/%{name}
LOGDIR=%{_localstatedir}/log/%{name}
WORKDIR=%{_localstatedir}/lib/%{name}
BDBLIB=-L%{_libdir}
BDBINCLUDE=-I%{_includedir}
LIBDB=-ldb
export PREFIX
export MANDIR
export CONFDIR
export LOGDIR
export WORKDIR
export BDBLIB
export BDBINCLUDE
export LIBDB
_EOF_


%build
export EXTRA_CFLAGS="${RPM_OPT_FLAGS}"
%{__make} dep

%if %{opt}
%{__make} all spider fix_word_index
%else
%{__make} all.bc spider.bc fix_word_index.bc
%endif


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/{logrotate.d,sysconfig}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sbindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}/{failed_messages,messages,web}

%{__make} \
	PREFIX=${RPM_BUILD_ROOT}%{_prefix}                     \
	MANDIR=${RPM_BUILD_ROOT}%{_mandir}                     \
	CONFDIR=${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}        \
	LOGDIR=${RPM_BUILD_ROOT}%{_localstatedir}/log/%{name}  \
	WORKDIR=${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name} \
%if %{opt}
	install
%else
	install.bc
%endif

%if %{opt}
%{__install} -m 0755 spider            ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -m 0755 fix_word_index    ${RPM_BUILD_ROOT}%{_bindir}
%else
%{__install} -m 0755 spider.bc         ${RPM_BUILD_ROOT}%{_bindir}/spider
%{__install} -m 0755 fix_word_index.bc ${RPM_BUILD_ROOT}%{_bindir}/fix_word_index

%{__mv}      -f      ${RPM_BUILD_ROOT}%{_bindir}/%{name}.bc      \
	${RPM_BUILD_ROOT}%{_bindir}/%{name}
%{__mv}      -f      ${RPM_BUILD_ROOT}%{_bindir}/sks_add_mail.bc \
	${RPM_BUILD_ROOT}%{_bindir}/sks_add_mail
%endif

for TYPE in db recon; do
  %{__ln_s} %{_bindir}/%{name}  ${RPM_BUILD_ROOT}%{_sbindir}/%{name}-${TYPE}
done

%{__install} -m 0755 %{SOURCE1} ${RPM_BUILD_ROOT}%{_initrddir}/%{name}-db
%{__install} -m 0755 %{SOURCE2} ${RPM_BUILD_ROOT}%{_initrddir}/%{name}-recon
%{__install} -m 0644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 0644 %{SOURCE4} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

for CFG in mailsync membership sksconf; do
  %{__install} -m 0640 ${CFG}.sample ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/${CFG}
done

%{__install} -m 0640 procmailrc.sample \
	${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}/.procmailrc

%{__rm} -f ${RPM_BUILD_ROOT}%{_bindir}/%{name}_build.sh


%pre
if ! getent group  %{name} >/dev/null 2>&1; then
  /usr/sbin/groupadd -r %{name}
fi
if ! getent passwd %{name} >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -g %{name}       \
	-d %{_localstatedir}/lib/%{name} \
	-c "SKS Service user"            \
	-s /sbin/nologin %{name}
fi
exit 0			# Always pass


%post
/sbin/chkconfig --add %{name}-db
/sbin/chkconfig --add %{name}-recon

%post selinux
if /usr/sbin/selinuxenabled && [ -e /selinux/policyvers ]; then
  /sbin/fixfiles   -R %{name} restore
  /sbin/restorecon -R %{_localstatedir}/lib/%{name}
fi


%preun
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{name}-recon stop >/dev/null 2>&1
  /sbin/service %{name}-db    stop >/dev/null 2>&1

  /sbin/chkconfig --del %{name}-recon
  /sbin/chkconfig --del %{name}-db
fi


%postun
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{name}-db    condrestart >/dev/null 2>&1 || :
  /sbin/service %{name}-recon condrestart >/dev/null 2>&1 || :
fi


%triggerin -- prelink, %{_sysconfdir}/prelink.conf
# Prevent prelink from modifying programs
if ! %{__grep} -q "%{_bindir}/{%{name}" %{_sysconfdir}/prelink.conf 2>/dev/null; then
  echo -e "-b %{_bindir}/{%{name},sks_add_mail,spider}" \
	>>%{_sysconfdir}/prelink.conf
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc BUGS CHANGELOG COPYING README TODO VERSION
%doc sks_build.sh
%{_initrddir}/%{name}-db
%{_initrddir}/%{name}-recon
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(750,root,%{name}) %dir %{_sysconfdir}/%{name}
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/mailsync
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/membership
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/sksconf
%{_bindir}/%{name}
%{_bindir}/sks_add_mail
%{_bindir}/spider
%{_bindir}/fix_word_index
%{_sbindir}/%{name}-db
%{_sbindir}/%{name}-recon
%{_mandir}/man8/*.8*
%attr(750,%{name},%{name}) %dir %{_localstatedir}/lib/%{name}
%attr(700,%{name},%{name}) %dir %{_localstatedir}/lib/%{name}/failed_messages
%attr(700,%{name},%{name}) %dir %{_localstatedir}/lib/%{name}/messages
%attr(750,%{name},%{name}) %dir %{_localstatedir}/lib/%{name}/web
%attr(640,root,%{name}) %config(noreplace) %{_localstatedir}/lib/%{name}/.procmailrc
%attr(750,%{name},%{name}) %dir %{_localstatedir}/log/%{name}

%files selinux
%defattr(-,root,root)


%changelog
* Mon Sep 14 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.1.0-3
- Added joined cursor leak fix
- Added userid last word downcase fix
- Added stats calc trigger on -USR2
- Fixed missing pidfile on startup

* Sun Mar 29 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.1.0-2
- Fixed config search path

* Fri Mar 27 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.1.0-1
- New version (1.1.0)

* Thu May 18 2006 peter.pramberger@member.fsf.org
- Current export of my tla archive sks--devel--1.1 (patch-14)
- added SELinux check

* Sun Oct 16 2005 peter.pramberger@member.fsf.org
- Current export of my tla archive sks--devel--1.1 (patch-13)
- some spec file cleanups

* Sat Sep 17 2005 peter.pramberger@member.fsf.org
- Current export of my tla archive sks--devel--1.1 (patch-12)
- created
